
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 29/OCT/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Oct 29 22:26:30 EST 2007, v0.01 sdy

*/

//  PACKAGE

#include "ErrorMessage.h"


ErrorMessage::ErrorMessage() :
  message_()
{
}

ErrorMessage::ErrorMessage(std::string const & message) :
  message_(message)
{
}

ErrorMessage::~ErrorMessage()
{
}

void
ErrorMessage::clear()
{
  message_.str("");
}

ErrorMessage &
ErrorMessage::operator<<(std::string s)
{
  message_ << s;
  return *this;
}

ErrorMessage &
ErrorMessage::operator<<(manip_t f)
{
  manip_t const flushp = std::flush;
  manip_t const endl = std::endl;
  if (f == endl) {
    (*this).operator<<("\n");
  } else if (f == flushp) {
    clear();
  }
  return *this;
}

std::ostream &
operator<<(std::ostream & os, ErrorMessage const & errorMessage)
{
  os << errorMessage.message_.str();
  return os;
}
