
/*
      _______                          .__ .__   .__   .__                 
      \      \    ____   __ __ _______ |__||  |  |  |  |__|  ____    ____  
      /   |   \ _/ __ \ |  |  \\_  __ \|  ||  |  |  |  |  | /  _ \  /    \ 
     /    |    \\  ___/ |  |  / |  | \/|  ||  |__|  |__|  |(  <_> )|   |  \
     \____|__  / \___  >|____/  |__|   |__||____/|____/|__| \____/ |___|  /
    =========\/======\/=================================================\/==
  v0.01 29/OCT/2007  Copyright 2007-2007 Scott D. Yelich SOME RIGHTS RESERVED


  LICENSE:  Creative Commons Attribution 3.0 License.
  SEE:      http://creativecommons.org/licenses/by/3.0/


  Mon Oct 29 22:26:30 EST 2007, v0.01 sdy

  This is ErrorMessage.h, part of ErrorMessage.

  See ErrorMessage.cpp for implementation details.

*/

#ifndef ERRORMESSAGE_H
#define ERRORMESSAGE_H


//  C++

#include <iostream> 
#include <iomanip> 
#include <sstream>
#include <ostream> 
#include <string>

class ErrorMessage
{

  public:

   ErrorMessage();
   ErrorMessage(std::string const & message);
  ~ErrorMessage();

  typedef std::ostream & (*manip_t)(std::ostream&);

  ErrorMessage & operator<<(std::string string);
  ErrorMessage & operator<<(manip_t f);

  friend std::ostream & operator<<(std::ostream & os, ErrorMessage const & errorMessage);

  void clear();

  private:

  std::stringstream message_;
  
};

#endif
